//+------------------------------------------------------------------+
//|                                                  ShowTFAData.mq4 |
//|                                                           Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "http://candid.110mb.com/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 RoyalBlue
#property indicator_level1 0.5
#property indicator_levelcolor White
#property indicator_minimum 0.0
#property indicator_maximum 1.0

extern int		Sample   				= 50;
extern int		ind_Points				= 20;
extern double	ind_Percent				= 0.0;
extern int		Column   				= 2;

string FileName;
string IndName;
int iPercent;
int pos;
int h;
//int PreBars;
//datetime BarTime;
//int StartPos;

datetime T;
double Val;

double Buf[];
double Buf2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  iPercent = 100*ind_Percent;
  IndName = "TFAData("+Sample+","+ind_Points+","+iPercent+","+Column+")";
  IndicatorShortName(IndName); 

  SetIndexBuffer(0,Buf);
//  SetIndexStyle(0,DRAW_LINE,EMPTY,2);
//  SetIndexStyle(0,DRAW_SECTION,EMPTY,2);
  SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,2);
  SetIndexEmptyValue(0,0.0);

  SetIndexBuffer(1,Buf2);
//  SetIndexStyle(1,DRAW_LINE,EMPTY,2);
//  SetIndexStyle(1,DRAW_SECTION,EMPTY,2);
  SetIndexStyle(1,DRAW_LINE,EMPTY,2);
  SetIndexEmptyValue(1,0.0);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  ObjectDelete("Show_"+FileName);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  FileName = "TFA_"+Symbol()+"_"+Sample+"_"+ind_Points+"_"+iPercent+".txt";
  h = FileOpen(FileName,FILE_CSV|FILE_READ,';');
  if (h<1) {
    ObjectCreate("Show_"+FileName,OBJ_LABEL,WindowFind(IndName),0,0);
    ObjectSet("Show_"+FileName,OBJPROP_CORNER,0);
    ObjectSet("Show_"+FileName,OBJPROP_XDISTANCE,20);
    ObjectSet("Show_"+FileName,OBJPROP_YDISTANCE,20);
    ObjectSetText("Show_"+FileName,", -   .",30,"Times New Roman",Red);
    return(-1);
  }
  for (pos=Bars-1;pos>0;pos--) {
    while (T < Time[pos] && !FileIsEnding(h)) {
      T = FileReadNumber(h);
      for (int i=0;i<4;i++) {
        double TVal = FileReadNumber(h);
        if (i == Column-2) Val = TVal;
      }
    }
    if (T >= Time[pos] && T < Time[pos-1]) {
      Buf[pos] = Val;
    }
//    } else {
//      if (!FileIsEnding(h)) Buf[pos] = Buf[pos+1];
//    }
  }  //  for (pos=StartPos;pos>0;pos--)  
  for (pos=1;pos<Bars;pos++) {
    if (Buf[pos] != 0.0) Buf2[pos] = Buf[pos];
    else Buf2[pos] = Buf2[pos-1];
  }
  FileClose(h); 
  return(0);
}
//+------------------------------------------------------------------+